'Programmed by Dakusan.  Please do not redistribute without credit.
'RABiD BUNNY FEVER

'Assembly information
Imports System
Imports System.Reflection
Imports System.Runtime.InteropServices
<Assembly: AssemblyTitle("Image Zoom")> 
<Assembly: AssemblyDescription("Quick cropping and resizing of images (http://www.castledragmire.com/Projects/Image_Zoom)")> 
<Assembly: AssemblyCompany("Hyrulean Productions")> 
<Assembly: AssemblyProduct("Image Zoom")> 
<Assembly: AssemblyCopyright("(Dakusan) Copyright  2008")> 
<Assembly: CLSCompliant(True)> 
<Assembly: Guid("60161DF5-9EFD-4096-B6EA-01E97ADDD451")> 
<Assembly: AssemblyVersion("1.0.0")> 

Public Class ImageZoom
    Inherits System.Windows.Forms.Form
    Dim ScreenDims As SizeF 'Screen dimensions
    Dim StartMouse As Point 'Remembering mouse positioning
    Dim ZoomRect As Rectangle, OutputSize As SizeF 'Selected rectangles
    Dim ProgramState As Integer 'State of the progrm
    Dim DesktopImage As Image, BackBuffer As Image, BackGraphic As Graphics 'Images for drawning
    Dim NumSaves As Integer
    Dim RandomSession As Integer

    'Generic win32 functions
    Private Declare Function GetDesktopWindow Lib "user32" Alias "GetDesktopWindow" () As IntPtr
    Private Declare Function GetDC Lib "user32" Alias "GetDC" (ByVal hwnd As IntPtr) As IntPtr
    Private Declare Function BitBlt Lib "gdi32" Alias "BitBlt" (ByVal hDestDC As IntPtr, ByVal x As Integer, ByVal y As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal hSrcDC As IntPtr, ByVal xSrc As Integer, ByVal ySrc As Integer, ByVal dwRop As Integer) As Integer
    Private Declare Function CreateCompatibleBitmap Lib "gdi32" Alias "CreateCompatibleBitmap" (ByVal hdc As IntPtr, ByVal nWidth As Integer, ByVal nHeight As Integer) As IntPtr
    Private Declare Function CreateCompatibleDC Lib "gdi32" Alias "CreateCompatibleDC" (ByVal hdc As IntPtr) As IntPtr
    Private Declare Function SelectObject Lib "gdi32" Alias "SelectObject" (ByVal hdc As IntPtr, ByVal hObject As IntPtr) As IntPtr
    Private Declare Function DeleteObject Lib "gdi32" Alias "DeleteObject" (ByVal hObject As IntPtr) As IntPtr
    Private Declare Function ReleaseDC Lib "user32" Alias "ReleaseDC" (ByVal hwnd As IntPtr, ByVal hdc As IntPtr) As IntPtr
    Private Const SRCCOPY = &HCC0020 ' (DWORD) dest = source


#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(ImageZoom))
        '
        'ImageZoom
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(712, 573)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "ImageZoom"
        Me.Text = "ImageZoom"

    End Sub

#End Region

    Private Sub ImageZoom_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Remove VB.NET flickering
        SetStyle(ControlStyles.UserPaint, True)
        SetStyle(ControlStyles.AllPaintingInWmPaint, True)
        SetStyle(ControlStyles.DoubleBuffer, True)

        'Create an image and graphics the size of the screen
        ScreenDims = New SizeF(Screen.PrimaryScreen.Bounds.Width, Screen.PrimaryScreen.Bounds.Height)
        BackBuffer = New Bitmap(ScreenDims.Width, ScreenDims.Height, Imaging.PixelFormat.Format32bppArgb) 'Create a back buffer invisible graphics handle for drawing using the main form as a template
        BackGraphic = Graphics.FromImage(BackBuffer)

        'Get the desktop image
        Me.Hide()
        Dim DesktopHWND As IntPtr = GetDesktopWindow()
        Dim DesktopHDC As IntPtr = GetDC(DesktopHWND)
        Dim GetDesktopBitmap As IntPtr = CreateCompatibleBitmap(DesktopHDC, ScreenDims.Width, ScreenDims.Height)
        Dim GetDesktopDC As IntPtr = CreateCompatibleDC(DesktopHDC)
        Dim OldPtr As IntPtr = SelectObject(GetDesktopDC, GetDesktopBitmap)
        BitBlt(GetDesktopDC, 0, 0, ScreenDims.Width, ScreenDims.Height, DesktopHDC, 0, 0, SRCCOPY)
        SelectObject(GetDesktopDC, OldPtr)
        DeleteObject(GetDesktopDC)
        ReleaseDC(DesktopHWND, DesktopHDC)
        Dim tempimage As Image = Image.FromHbitmap(GetDesktopBitmap)
        DesktopImage = New Bitmap(ScreenDims.Width, ScreenDims.Height, Imaging.PixelFormat.Format32bppArgb)
        Graphics.FromImage(DesktopImage).DrawImage(tempimage, 0, 0)
        DeleteObject(GetDesktopBitmap)
        Me.Show()

        'Make our window take the full screen
        Me.FormBorderStyle = FormBorderStyle.FixedToolWindow
        Me.WindowState = FormWindowState.Maximized 'Maximize window

        Randomize()

        DrawTitleScreen()
    End Sub

    Private Sub DrawTitleScreen() 'Draw title screen
        ProgramState = 0
        Dim TitleString As String = "Dakusan's Image Zoom for /b", TitleString2 = "Read the titlebar for instructions"
        Dim MyFont As Font = New Font(New FontFamily("Times New Roman"), 60, FontStyle.Regular, GraphicsUnit.Pixel)
        Dim MyFont2 As Font = New Font(New FontFamily("Times New Roman"), 20, FontStyle.Regular, GraphicsUnit.Pixel)
        Dim FontDims As SizeF = BackGraphic.MeasureString(TitleString, MyFont)
        Dim FontDims2 As SizeF = BackGraphic.MeasureString(TitleString2, MyFont2)
        BackGraphic.TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAlias 'Anti aliased text
        BackGraphic.Clear(Color.Gray)
        BackGraphic.DrawString(TitleString, MyFont, New SolidBrush(Color.Green), (ScreenDims.Width - FontDims.Width) / 2, (ScreenDims.Height - FontDims.Height) / 2)
        BackGraphic.DrawString(TitleString2, MyFont2, New SolidBrush(Color.Green), (ScreenDims.Width - FontDims2.Width) / 2, (ScreenDims.Height - FontDims.Height) / 2 + FontDims.Height)
        Me.Text = "Please drag on the form to select the final output size."
        Me.Refresh()
    End Sub
    Private Sub ImageZoom_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        e.Graphics.DrawImage(BackBuffer, 0, 0) 'Copy the BackBuffer to the main screen
    End Sub

    Private Sub ImageZoom_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
        'Store mouse position
        StartMouse.X = e.X
        StartMouse.Y = e.Y

        'Start program state
        Select Case ProgramState
            Case 0
                ProgramState = 1
                RestoreBackground()
                Me.Refresh()
                Me.Text = "Output Size: 0, 0"
            Case 2
                ProgramState = 3
        End Select
    End Sub

    Private Sub ImageZoom_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseUp
        'Move to next state
        Select Case ProgramState
            Case 1 'Figure out selection rectangle size
                ProgramState = 2
                Dim SelectRect As System.Drawing.Rectangle = New Rectangle(SelectVal(StartMouse.X < e.X, StartMouse.X, e.X), SelectVal(StartMouse.Y < e.Y, StartMouse.Y, e.Y), SelectVal(StartMouse.X > e.X, StartMouse.X, e.X), SelectVal(StartMouse.Y > e.Y, StartMouse.Y, e.Y))
                OutputSize.Width = SelectRect.Width - SelectRect.X
                OutputSize.Height = SelectRect.Height - SelectRect.Y
                If OutputSize.Width + OutputSize.Height < 10 Then 'Rectangle shouldnt be too small
                    ProgramState = 0
                    MsgBox("Box is too small")
                    Exit Sub
                End If
                Me.Text = "Please select the initial rectangle."
                RestoreBackground()
                Me.Refresh()
            Case 3 'Figure out initial selection rectangle
                ProgramState = 4
                Me.Text = "Please drag with the left mouse and rezoom with the right mouse, and click enter to save."
                NumSaves = 0
                RandomSession = Rnd() * 100000
                DrawZoomed()
        End Select
        System.GC.Collect(100) 'Reduce memory print
    End Sub

    Private Sub ImageZoom_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseMove
        Select Case ProgramState
            Case 1 'Draw rectangle
                Dim SelectRect As System.Drawing.Rectangle = New Rectangle(SelectVal(StartMouse.X < e.X, StartMouse.X, e.X), SelectVal(StartMouse.Y < e.Y, StartMouse.Y, e.Y), SelectVal(StartMouse.X > e.X, StartMouse.X, e.X), SelectVal(StartMouse.Y > e.Y, StartMouse.Y, e.Y))
                SelectRect.Width = SelectRect.Width - SelectRect.X
                SelectRect.Height = SelectRect.Height - SelectRect.Y
                Me.Text = "Output Size: " + Trim(SelectRect.Width) + ", " + Trim(SelectRect.Height)
                RestoreBackground()
                BackGraphic.FillRectangle(New System.Drawing.SolidBrush(System.Drawing.Color.FromArgb(&H770000BB)), SelectRect)
                Me.Refresh()
            Case 3 'Draw rectangle
                Dim SelectRect As Rectangle = New Rectangle(SelectVal(StartMouse.X < e.X, StartMouse.X, e.X), SelectVal(StartMouse.Y < e.Y, StartMouse.Y, e.Y), SelectVal(StartMouse.X > e.X, StartMouse.X, e.X), SelectVal(StartMouse.Y > e.Y, StartMouse.Y, e.Y))
                SelectRect.Width = SelectRect.Width - SelectRect.X
                SelectRect.Height = SelectRect.Height - SelectRect.Y
                If (SelectRect.Width / OutputSize.Width > SelectRect.Height / OutputSize.Height) Then
                    SelectRect.height = SelectRect.width / (OutputSize.Width / OutputSize.Height)
                Else
                    SelectRect.width = OutputSize.Width / OutputSize.Height * SelectRect.height
                End If
                ZoomRect = SelectRect
                RestoreBackground()
                BackGraphic.FillRectangle(New System.Drawing.SolidBrush(System.Drawing.Color.FromArgb(&H770000BB)), SelectRect)
                Me.Refresh()
            Case 4 'Scale and translate
                If e.Button = MouseButtons.Left Then
                    ZoomRect.X = ZoomRect.X + (StartMouse.X - e.X)
                    ZoomRect.Y = ZoomRect.Y + (StartMouse.Y - e.Y)
                ElseIf e.Button = MouseButtons.Right Then
                    Dim MoveScale As Integer = StartMouse.Y - e.Y
                    ZoomRect.Height = ZoomRect.Height + MoveScale
                    ZoomRect.Width = OutputSize.Width / OutputSize.Height * ZoomRect.Height
                End If
                StartMouse.X = e.X
                StartMouse.Y = e.Y
                DrawZoomed()
        End Select
    End Sub

    Public Sub DrawZoomed()
        BackGraphic.Clear(Color.Gray)

        Dim ao As Imaging.ColorMatrix = New Imaging.ColorMatrix(New Single()() _
                          {New Single() {1, 0, 0, 0, 0}, _
                           New Single() {0, 1, 0, 0, 0}, _
                           New Single() {0, 0, 1, 0, 0}, _
                           New Single() {0, 0, 0, 0.1, 0}, _
                           New Single() {0, 0, 0, 0, 1}})
        Dim AlphaOp As New Imaging.ImageAttributes
        AlphaOp.SetColorMatrix(ao)

        Dim CenterPoint As Point = New Point((ScreenDims.Width - OutputSize.Width) / 2, (ScreenDims.Height - OutputSize.Height) / 2)
        Dim ImageScaleX As Double = ZoomRect.Width / OutputSize.Width, ImageScaleY = ZoomRect.Height / OutputSize.Height
        BackGraphic.DrawImage(DesktopImage, New Rectangle(0, 0, ScreenDims.Width, ScreenDims.Height), CInt(ZoomRect.X - CenterPoint.X * ImageScaleX), CInt(ZoomRect.Y - CenterPoint.Y * ImageScaleY), CInt(ScreenDims.Width * ImageScaleX), CInt(ScreenDims.Height * ImageScaleY), GraphicsUnit.Pixel, AlphaOp)
        GraphicsQuality(True)
        BackGraphic.DrawImage(DesktopImage, New Rectangle(CenterPoint.X, CenterPoint.Y, OutputSize.Width, OutputSize.Height), ZoomRect, GraphicsUnit.Pixel)
        GraphicsQuality(False)
        Me.Refresh()
    End Sub

    Public Sub GraphicsQuality(ByVal SetHigh As Boolean) 'Turn on high or low quality graphics
        BackGraphic.InterpolationMode = SelectVal(SetHigh, Drawing2D.InterpolationMode.HighQualityBicubic, Drawing2D.InterpolationMode.Low)
        BackGraphic.SmoothingMode = SelectVal(SetHigh, Drawing2D.SmoothingMode.HighQuality, Drawing2D.SmoothingMode.HighSpeed)
        BackGraphic.PixelOffsetMode = SelectVal(SetHigh, Drawing2D.PixelOffsetMode.HighQuality, Drawing2D.PixelOffsetMode.HighSpeed)
    End Sub

    Public Function SelectVal(ByVal IsTrue As Boolean, ByVal Val1 As Object, ByVal Val2 As Object) As Object 'like "? :" operators in c
        If IsTrue Then Return Val1
        Return Val2
    End Function

    Public Sub RestoreBackground() 'Draw background on backbuffer
        BackGraphic.DrawImage(DesktopImage, 0, 0)
    End Sub

    Private Sub ImageZoom_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles MyBase.KeyPress
        If ProgramState <> 4 Or Not e.KeyChar = Chr(13) Then Exit Sub 'Check in final state and if enter is pressed

        'Get save path from ini
        Dim SR As IO.StreamReader
        Try
            SR = IO.File.OpenText("ImageZoomPath.ini")
        Catch ex As IO.FileNotFoundException
            MsgBox("ImageZoomPath.ini file not found.")
            Exit Sub
        End Try
        Dim SavePath As String = SR.ReadLine()
        SR.Close()

        Dim FindStrings As Object() = {"UserDir", "Desktop", "MyPictures", "Date", "Time", "Num", "RandomSession", "Ticks"}
        Dim ReplaceStrings As Object() = {Environment.GetFolderPath(Environment.SpecialFolder.Personal), _
            Environment.GetFolderPath(Environment.SpecialFolder.Desktop), _
            Environment.GetFolderPath(Environment.SpecialFolder.MyPictures), _
            CStr(Date.Now.Month) + "-" + CStr(Date.Now.Day) + "-" + CStr(Date.Now.Year), _
            CStr(Date.Now.Hour).PadLeft(2, "0") + "." + CStr(Date.Now.Minute).PadLeft(2, "0") + "." + CStr(Date.Now.Second).PadLeft(2, "0"), _
            NumSaves, _
            RandomSession, _
            DateTime.Now.Ticks}
        NumSaves = NumSaves + 1
        Dim i As Integer
        For i = 0 To 7
            SavePath = SavePath.Replace("%" + FindStrings(i) + "%", Trim(ReplaceStrings(i)))
        Next I

        'Get the image
        Dim SaveImage As Image = New Bitmap(OutputSize.Width, OutputSize.Height, Imaging.PixelFormat.Format32bppArgb)
        GraphicsQuality(True)
        Graphics.FromImage(SaveImage).DrawImage(DesktopImage, New Rectangle(0, 0, OutputSize.Width, OutputSize.Height), ZoomRect, GraphicsUnit.Pixel)
        GraphicsQuality(False)

        'Save image
        Try
            SaveImage.Save(SavePath, Imaging.ImageFormat.Jpeg)
        Catch ex As Exception
            MsgBox("Error saving file, path invalid? " + SavePath)
        End Try
        SaveImage.Dispose()
    End Sub

    Private Sub ImageZoom_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyUp
        If e.KeyCode = Keys.F5 Then DrawTitleScreen()
    End Sub
End Class